function frmMainLoaded()
	if(GetNumGuildMembers(1)==0) then
		print("Elgoh: An error has occurred, you are not in a guild?");
	else
		for i = 1, GetNumGuildMembers(0), 1 do 
			name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
			if(name==UnitName("player")) then
				playername=name;
				elgohrank=rankIndex;
				playerrealm=GetRealmName();
				playerguild=GetGuildInfo("player");
				if(legend==nil) then legend="Chuck Norris"; end
				if(legend_short==nil) then legend_short="Chuck"; end
				btnHatfield:SetText(legend);
				edtLegend:SetText(legend);
				edtLegend_Short:SetText(legend_short);
				tinsert(UISpecialFrames,"frmMain");
				tinsert(UISpecialFrames,"frmOfficer");
				frmMain:RegisterForDrag("LeftButton");
				frmMain:UnregisterEvent("PLAYER_LOGIN");
				frmOfficer:RegisterEvent("CHAT_MSG_ADDON");
				frmOfficer:RegisterEvent("PARTY_LOOT_METHOD_CHANGED");
				frmOfficer:RegisterForDrag("LeftButton");
				RegisterAddonMessagePrefix("lgoh");
				-- Version Print
				if(oldversion==nil) then oldversion="1"; end -- Fix a bug when comparing to oldversion=nil
				vers = GetAddOnMetadata("ELGoH", "X-Curse-Packaged-Version") 
				if(playername=="Taurast" and playerrealm=="Khadgar") then vers="r60"; end
				vers = string.sub(vers, 1);
				if(vers>oldversion or playername=="Taurast") then
					print("Welcome to ELGoH "..vers..".\nType /elgoh info for a list of commands.");
					oldversion=vers;
				end
				-- End Version Print
				break;
			end
		end
	end
end

function elgohTimer(timeinmins)
	if(IsAddOnLoaded("DBM-Core")) then
		SendChatMessage("Breaktime!", "RAID")
		DBM:CreatePizzaTimer(60*timeinmins, "Breaktime", 1, "The Officers")
	else
		print("Elgoh: Timers require Deadly Boss Mods");
	end
end

function lgohInfo()
	print("|cFF00FF00Welcome to the LGoH addon! If you find anything that doesn't work (or does work), or something you feel could do with a little tweaking feel free to message me in game :)\n");
	print("|cFF00FF00If a box is left blank, it will apply to yourself, or your target if you have one");
	print("|cFF00FF00Shift Clicking the top button in the Fun Panel will allow you to change the legendary character in the Legend Facts database (a few of them will have bad grammar)");
	local elgohcommands = {"/elgoh - Shows the main frame",
							"/elgoh clean - Cleans inactive guild members, inactive for 30 days or 20 days for alts (ignores NOKICK officer notes)",
							"/breaktime <time in minutes> - Starts a DBM timer for the specified time (Requires DBM)",
							""};	
	print("Elgoh Commands:\n");
	for i=1, #elgohcommands, 1 do
		print(elgohcommands[i]);
	end
end
   
function possessTarget()
	if(UnitName("target")~=nil) then
		if(pA==nil) then
			print("You must type \"/anoo possess-allow\" to enable this feature. Warning, you will be vulnerable to possessions as well");
		else
			SendAddonMessage("lgoh", edtPTarget:GetText(), "WHISPER", UnitName("target"));
		end
	else
		print("No Target");
	end
end

function elgohMessage(event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = select(1, ...);
		if(prefix=="lgoh") then
			if(pA==1) then
				print(who.." possessed you...");
				if(GetNumRaidMembers()>1) then
					SendChatMessage(msg, RAID);
				elseif(GetNumPartyMembers()>1) then
					SendChatMessage(msg, PARTY);
				else
					SendChatMessage(msg, SAY);
				end
			else
				print(who.." tried to possess you");
			end
		end
	end
	if(event=="PARTY_LOOT_METHOD_CHANGED") then
		lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod();
		if(lootmethod=="master") then
			if(masterlooterRaidID) then
				name = GetRaidRosterInfo(masterlooterRaidID);
			elseif(masterlooterPartyID) then
				name = GetRaidRosterInfo(masterlooterPartyID);
			end
			if(name~=nil and name~="") then
				edtMaster:SetText("Master Looter: "..name);
			end
		end
	end
end

function Rottgut()
kick=0;
	for i = 1, GetNumGuildMembers(1), 1 do 
		yearsOffline, monthsOffline, daysOffline, hoursOffline = GetGuildRosterLastOnline(i);
		name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
		if((online~=1 and (daysOffline>=20 and rankIndex==7) and level<=50)) then 
			print("Kicking "..name..": Inactive Alt")
			GuildUninvite(name);
			kick=kick+1;
		elseif((online~=1 and (daysOffline>=29 or monthsOffline>0) and officernote~="NoKick")) then
			print("Kicking "..name..": Inactive Member")
			GuildUninvite(name);
			kick=kick+1;
		end
	end
	if(kick==0) then print("Elgoh: No inactive players"); end
end

function PostTo_OnClick(self)
  local i = self:GetID()
  UIDropDownMenu_SetSelectedID(DropPostTo, i)
end

function PostTo_OnShow()
	UIDropDownMenu_Initialize(DropPostTo,PostTo_Initialize)
	UIDropDownMenu_SetSelectedID(DropPostTo, 1)
end

function PostTo_Initialize()
	PostToChoice = {"|cff00ff00Guild", "|cffff4444Raid", "|cff6655ffParty", "Say", "|cff999999Self"};
	local i;
	if(getn(PostToChoice) > 0) then
		for i = 1, getn(PostToChoice), 1 do
			info = {
				text = PostToChoice[i],
				func = PostTo_OnClick
			}
			UIDropDownMenu_AddButton(info)
		end
	end
end

SLASH_LGOH1 = "/lgoh"
SlashCmdList["LGOH"] = function(msg, editBox)
msg = strlower(msg);
    if(msg=="officer" or msg=="o") then
		if (elgohrank==0 or elgohrank==1 or elgohrank==2) then
			frmOfficer:Show();
		else
			print("You are not ranked high enough at "..elgohrank..", requires 0 or 1 or 2");
		end
    elseif(msg=="rottgut" or msg=="clean") then
		if (elgohrank==0 or elgohrank==1 or elgohrank==2) then
			Rottgut();
		else
			print("You are not ranked high enough at "..elgohrank..", requires 0 or 1 or 2");
		end
	elseif(msg=="info") then
		lgohInfo()
	elseif(msg=="startdkp") then
		StartDKP()
	else
		frmMain:Show();
    end
end

SLASH_ELGOH1 = "/elgoh"
SlashCmdList["ELGOH"] = function(msg, editBox)
msg = strlower(msg);
    if(msg=="officer" or msg=="o") then
		if (elgohrank==0 or elgohrank==1) then
			frmOfficer:Show();
		else
			print("You are not ranked high enough at "..elgohrank..", requires 0 or 1");
		end
	elseif(msg=="clean") then
		if (elgohrank==0 or elgohrank==1) then
			Rottgut();
		else
			print("You are not ranked high enough at "..elgohrank..", requires 0 or 1");
		end
	elseif(msg=="info") then
		lgohInfo()
	elseif(msg=="startdkp") then
		StartDKP()
	else
		frmMain:Show();
    end
end

SLASH_ANOO1 = "/anoo"
SlashCmdList["ANOO"] = function(msg, editBox)
msg = strlower(msg);
	if(msg=="dev") then
		devel=1;
	elseif(msg=="possess-allow") then
		pA=1;
		print("Allowing Possessions, type /anoo possess-disable");
	elseif(msg=="possess-disable") then
		pA=0;
		print("Disabling Possessions");
	else
		ReloadUI();
	end
end

SLASH_LGOHB1 = "/breaktime"
SlashCmdList["LGOHB"] = function(msg, editBox)
	elgohTimer(msg);
end

function SetMaster()
if(edtMaster:GetText()=="Not Set" or edtMaster:GetText()=="") then 
	edtMaster:SetText("Not Set");
	if(UnitName("target")==nil) then 
		SetLootMethod("master", UnitName("player"));
		SetLootThreshold(3);
		edtMaster:ClearFocus();
	else
		SetLootMethod("master", UnitName("target"));
		SetLootThreshold(3);
		edtMaster:ClearFocus();
	end
else
	SetLootMethod("master", edtMaster:GetText());
	SetLootThreshold(3);
	edtMaster:ClearFocus();
end
end

function Blame()
	if(UIDropDownMenu_GetSelectedID(DropPostTo)==2 and GetNumRaidMembers()) then
		i = random(1,GetNumRaidMembers());
		name = GetRaidRosterInfo(i);
		PostTo("I blame " ..name.. ".");
	elseif (UIDropDownMenu_GetSelectedID(DropPostTo)==1) then
		guildies=GetNumGuildMembers(false);
		i = math.random(1, guildies); 
		name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
		if(online) then 
			PostTo("I blame " ..name.. ".");
		else
			Blame();
		end
	end
end

function PostTo(str)
		if (UIDropDownMenu_GetSelectedID(DropPostTo)<5) then 
			Chattype= str.sub(PostToChoice[UIDropDownMenu_GetSelectedID(DropPostTo)], 11);
			SendChatMessage(str, Chattype); 
		else
			print(str); 
		end
end

function RandomHaydies()
	local RANDOM_JOKES = {"My groups don't wipe, we just decide to have a leisurely stroll back through the instance",
	"Hey guys, I heard they moved Thunder Bluff into Org",
	"Hey guys, does anyone need a DPL?",
	"You should be allowed to use Potions of Illsion on your pets, imagine having a pet "..playername..", that would be awesome, if a little arousing"};	
	local index = random(1, #RANDOM_JOKES);
	local str = RANDOM_JOKES[index];
	PostTo(str);
end
